package com.company.example.screen.resourerolecustom;

import com.google.common.collect.Sets;
import io.jmix.security.model.RoleSource;
import io.jmix.security.model.SecurityScope;
import io.jmix.securityui.model.ResourceRoleModel;
import io.jmix.securityui.screen.resourcerole.ResourceRoleModelBrowse;
import io.jmix.ui.ScreenBuilders;
import io.jmix.ui.action.Action;
import io.jmix.ui.component.GroupTable;
import io.jmix.ui.screen.StandardLookup;
import io.jmix.ui.screen.Subscribe;
import io.jmix.ui.screen.UiController;
import io.jmix.ui.screen.UiDescriptor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("ext_sec_ResourceRoleModel.browse")
@UiDescriptor("ext-resource-role-model-browse.xml")
public class ExtResourceRoleModelBrowse extends StandardLookup<ResourceRoleModel> {
    private static final Logger log = LoggerFactory.getLogger(ResourceRoleModelBrowse.class);
    @Autowired
    private ScreenBuilders screenBuilders;
    @Autowired
    private GroupTable<ResourceRoleModel> roleModelsTable;

    @Subscribe("roleModelsTable.create")
    public void onRoleModelsTableCreateResourceRole(Action.ActionPerformedEvent event) {
        ExtResourceRoleModelEdit editor = screenBuilders.editor(ResourceRoleModel.class, this)
                .withScreenClass(ExtResourceRoleModelEdit.class)
                .newEntity()
                .withInitializer(roleModel -> {
                    roleModel.setSource(RoleSource.DATABASE);
                    roleModel.setScopes(Sets.newHashSet(SecurityScope.UI));
                })
                .build();
        editor.setOpenedByCreateAction(true);
        editor.show();
    }

}