/*
 * Copyright 2020 Haulmont.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.company.example.screen.resourerolecustom;

import com.company.example.screen.resourerolecustom.dto.MapViewMenuDTO;
import io.jmix.securityui.model.ResourceRoleModel;
import io.jmix.ui.component.TreeDataGrid;
import io.jmix.ui.component.TreeTable;
import io.jmix.ui.model.CollectionContainer;
import io.jmix.ui.navigation.Route;
import io.jmix.ui.screen.*;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;
import java.util.List;

@UiController("ext.sec_ResourceRoleModel.edit")
@UiDescriptor("ext-resource-role-model-edit.xml")
@EditedEntityContainer("roleModelDc")
@Route(value = "extResourceRoles/edit", parentPrefix = "resourceRoles")
public class ExtResourceRoleModelEdit extends StandardEditor<ResourceRoleModel> {
    @Autowired
    private CollectionContainer<MapViewMenuDTO> viewMenuDTOsDc;
    @Autowired
    private TreeTable<MapViewMenuDTO> viewMenuDTOsTable;
    @Autowired
    private ExtResourcePolicyEditorUtils extResourcePolicyEditorUtils;
    private boolean openedByCreateAction;
    @Autowired
    private TreeDataGrid<MapViewMenuDTO> mapViewMenuDToesTable;

    public void setOpenedByCreateAction(boolean openedByCreateAction) {
        this.openedByCreateAction = openedByCreateAction;
    }

    @Subscribe
    public void onBeforeShow(BeforeShowEvent event) {
        /** Start custom role*/
        initAndConvertResourceMenuViewDc();
        viewMenuDTOsTable.expandAll();
        mapViewMenuDToesTable.expandAll();
    }

    //Start custom role

    /**
     * init tabble entity với table
     */
    private void initAndConvertResourceMenuViewDc() {
        List<MapViewMenuDTO> listAll = new ArrayList<>();
        List<MapViewMenuDTO> listMenu = extResourcePolicyEditorUtils.getMenuItemOptionsMapTree();
        List<MapViewMenuDTO> listScreen = extResourcePolicyEditorUtils.getScreenOptionsMap();
        listAll.addAll(listMenu);
        listAll.addAll(listScreen);

        viewMenuDTOsDc.setItems(listAll);
    }

}
